

//all cegui stuff should be inited by now

//register custom classes (they should be included in the beginning of file)
CEGUI::WindowFactoryManager::getSingleton().addFactory<CEGUI::TplWindowFactory<CEGUI::HSplitter> >();
CEGUI::WindowFactoryManager::getSingleton().addFactory<CEGUI::TplWindowFactory<CEGUI::HLayoutContainer> >();

//create custom horizontal layout container
CEGUI::HLayoutContainer* hlc = static_cast<CEGUI::HLayoutContainer*>(CEGUI::WindowManager::getSingletonPtr()->createWindow("CEGUI/HLayoutContainer"));
//expand it so it fills whole parent
hlc->setSize(CEGUI::USize(cegui_reldim(1), cegui_reldim(1)));
//wnd is, for example, any already created frame window that was attached to root (or anything else)
wnd->addChild(hlc);

//variables to store some windows so we can modify them later
CEGUI::FrameWindow* window = 0;
CEGUI::FrameWindow* window0 = 0;
CEGUI::FrameWindow* window1 = 0;
CEGUI::FrameWindow* window4 = 0;

for (int i = 0; i < 5; ++i) //add 5 windows to layout
{
	std::stringstream stringStream;
	stringStream << "Window #" << i;

	window = static_cast<CEGUI::FrameWindow*>(CEGUI::WindowManager::getSingletonPtr()->createWindow("GlossySerpent/FrameWindow"));

	if (i == 0)
		window0 = window;

	if (i == 1)
		window1 = window;

	if (i == 4)
		window4 = window;

	window->setSize(CEGUI::USize(cegui_absdim(300), cegui_absdim(300)));
	window->setText(stringStream.str());
	//we don't want user to resize or move our windows
	window->setSizingEnabled(false);
	window->setDragMovingEnabled(false);
	
	window->setCloseButtonEnabled(false);

	hlc->addChild(window);
}

//test some features (uncomment)

//hlc->moveChildToPosition(window4, 0);
//hlc->moveChildToPosition(window0, 4);
//hlc->swapChildPositions(1, 3);
//hlc->removeChild(window0);

